//#include </home/lucadn/Lavoro/Omsim/CVS/Omsim/Libs/Connection.cc>
#include "Connection.h"
#include "connList.h"

void connList::insertConn(int connID, int sourceID, int destinationID, Status status, bool backward, int attempts, int totalPackets, int tipo, int classe, int bitRate, double packetPeriod, double costo, double lastRxTime, double requestTime)
{
    Connection *pointer=startList;
    while(pointer)
      {
		
	if((pointer==startList)&&((connID<pointer->_connID)||((pointer->_connID==connID)&&(sourceID<pointer->_sourceID))))
    	{    
	    Connection *newConn= new Connection(connID, sourceID, destinationID, status, backward, attempts, totalPackets, tipo, classe,bitRate, packetPeriod, costo,lastRxTime,requestTime,0);
	    newConn->next=pointer;
	    startList=newConn;
	    return;
	}
	if(pointer->next)
	{
	    bool condition1=((pointer->_connID<connID)||((pointer->_connID==connID)&&(pointer->_sourceID<sourceID)));
	    bool condition2=((connID<(pointer->next)->_connID)||(((pointer->next)->_connID==connID)&&(sourceID<(pointer->next)->_sourceID)));
	    if(condition1 && condition2)
	    {    
	        Connection *newConn= new Connection(connID, sourceID, destinationID, status, backward, attempts, totalPackets, tipo, classe,bitRate, packetPeriod,costo,lastRxTime,requestTime,0);
	        newConn->next=pointer->next;
	        pointer->next=newConn;
	        return;
	    }
	    pointer=pointer->next;
	}
	else
	{
	    Connection *newConn= new Connection(connID, sourceID, destinationID, status, backward, attempts, totalPackets, tipo, classe,bitRate, packetPeriod,costo,lastRxTime,requestTime,0);
	    newConn->next=0;
	    pointer->next=newConn;
	    return;
	}
    }
    Connection *newConn= new Connection(connID, sourceID, destinationID, status, backward, attempts, totalPackets, tipo, classe,bitRate, packetPeriod,costo,lastRxTime,requestTime,0);
    newConn->next=0;
    startList=newConn;
    return;
}

void connList::removeConn(int connID, int sourceID)
{
    Connection *pointer=startList;
    Connection *temp;
    //cout<<"Entrato in removeConn\n";
    
    if((startList)&&(startList->_connID==connID)&&(startList->_sourceID==sourceID))
    {
	temp=startList;
	startList=startList->next;
	delete temp;
	return;
    }
    while(pointer)
    {
	if(pointer->next)
	{    
	    if(((pointer->next)->_connID==connID)&&((pointer->next)->_sourceID==sourceID))
	    {
		//cout<<"In removeConn: connessione da eliminare trovata\n";
		temp=pointer->next;
		pointer->next=(pointer->next)->next;
		delete temp;
		pointer=0;
		return;
	    }
	    
	    //cout<<"In removeConn: incrementato il puntatore\n";
	}
	pointer=pointer->next;
    }
    //cout<<"Finito removeConn\n";
}

Connection * connList::searchConn(int connID, int sourceID)
{
    //cout<<"Entrato in search conn\n";
    Connection *pointer=startList;
    while(pointer)
    {
	//if(pointer->next)
	//{    
	    if((pointer->_connID==connID)&&(pointer->_sourceID==sourceID))
	    //if(((pointer->next)->_connID==connID)&&((pointer->next)->_sourceID==sourceID))
	    {
		//cout<<"Uscendo da search conn: connessione trovata\n";
		return(pointer);
		//return(pointer->next);
	    }
	//}
	pointer=pointer->next;
    }
    //cout<<"Uscendo da search conn: connessione non trovata\n";
    return(0);
}
void connList::print()
{
    Connection *pointer=startList;
    while(pointer)
    {
	
	/*switch(pointer->_status)
	{
	
	    case requested:
	    {
		
		char statusStr[10]="requested";
	    }
	    break;
	    case reserved:
	    {
		char statusStr[10]="reserved";
	    }
	    break;
	    case waiting:
	    {
		char statusStr[10]="waiting";
	    }
	    break;
	    case active:
	    {
		char statusStr[10]="active";
	    }
	    break;
	    case broken:
	    {
		char statusStr[10]="broken";
	    }
	    break;
	}*/
	cout<<"Source: "<<pointer->_sourceID<<"; Dest: "<<pointer->_destinationID<<"; ID: "<<pointer->_connID<<"; status: "<<pointer->_status<<endl;
	pointer=pointer->next;
    }
    cout<<endl;
}
