#ifndef _Connection
#define _Connection
#include <vector.h>
enum Status {requested,waiting,reserved,active,broken};

class Connection{

public:
    
    Connection(int connID,int sourceID, int destinationID, Status status, bool backward, int attempts, int totalPackets, int tipo, int classeservizio, int bitRate,  double packetPeriod, double costo, double lastRxTime, double requestTime,int ackPackets=0);
    int _connID;
    int _sourceID;
    int _destinationID;
    Status _status;
    bool _backward;
    int _attempts;
    int _remainingPackets;
    //int _receivedPackets;
    int _totalPackets;
    int _ackPackets;
    int _tipo;
    int _classeservizio;
    int _bitRate;
    double _costo;
    double _lastRxTime;
    double _requestTime;
    double _packetPeriod;
    double _nextDATATxTime;
    //double _meanDelay;
    vector <int> _path;
    Connection *next;

};
#endif
